
-- Indicateur sur le plugin dragbar est prsent

_G.dragBarAvailable = pcall( function(sender,args)
	import "Deusdictum.UI.DragBar";
end );



-- Dump table function for checking tables on the fly ---------------
_G.dump = function (o)
    if type(o) == 'table' then
        local s = '{\n'
        for k,v in pairs(o) do
                if type(k) ~= 'number' then k = '"'..k..'"' end
                s = s .. '['..k..'] = ' .. dump(v) .. '\n'
        end
        return s .. '}\n'
    else
        return tostring(o)
    end
end


--This function returns a deep copy of a given table ---------------
_G.deepcopy = function(object)
    local lookup_table = {}
    local function _copy(object)
        if type(object) ~= "table" then
            return object
        elseif lookup_table[object] then
            return lookup_table[object]
        end
        local new_table = {}
        lookup_table[object] = new_table
        for index, value in pairs(object) do
            new_table[_copy(index)] = _copy(value)
        end
        return setmetatable(new_table, getmetatable(object))
    end
    return _copy(object)
end


-- This function merges table two into table one, overwriting any matching entries.
_G.mergeTables=function(t1, t2)
	for k, v in pairs(t2) do
		if (type(v) == "table") and (type(t1[k] or false) == "table") then
			mergeTables(t1[k], t2[k])
		else
			t1[tostring(k)] = v
		end
	end
	return t1
end

-- Recupere la langue du client
_G.getClientLanguage = function()
	
	if Turbine.Shell.IsCommand("hilfe") then
		return "GERMAN";
	elseif Turbine.Shell.IsCommand("aide") then
		return "FRENCH";
	else 
		return "ENGLISH";
	end
end



-- This is the callback mechanism provided by Pengoros
_G.AddCallback = function (object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end

-- safely remove a callback without clobbering any extras
_G.RemoveCallback = function (object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end



