
-- Parametres globaux
gPluginName="KikiRolls";
gDebug = {};

-- Import 
import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";

import "Kiki.Commons.Trace";
import "Kiki.Commons.UTF";
import "Kiki.Commons.Class";
import "Kiki.Commons.Tools";
import "Kiki.Commons.Settings";
import "Kiki.Commons.Tooltips";
import "Kiki.Commons.Onscreen";
import "Kiki.KikiRolls.Languages";

-- Charge les traductions
gLanguage = getClientLanguage();
gLang = getLang(gLanguage); 

-- Joueur
gPlayer = Turbine.Gameplay.LocalPlayer.GetInstance();
gPlayerName = gPlayer:GetName();


-- Fenetre d'affichage des rolls
import "Kiki.KikiRolls.wRolls";

-- Function de dechargment du plugin
Plugins[gPluginName].Unload = function(self,sender,args)
	wRolls:Unload();
	Kiki.Commons.Trace("unloaded");
end

-- Tracker du mode combat
gPlayer.InCombatChanged = function(sender, args)
	wRolls:CombatMode(gPlayer:IsInCombat());
end

-- tracker du chat
Turbine.Chat.Received =	
	function (s,a) 
		wRolls:FilterMessage(s,a);
	end;

-- commande /ds /rolls (de ?)
scCommand = Turbine.ShellCommand();
Turbine.Shell.AddCommand(gLang.COMMAND, scCommand);
function scCommand:GetShortHelp()
    return gLang.USAGE;
end
function scCommand:GetHelp()
    return self:GetShortHelp();
end
function scCommand:Execute(cmd, args)
	-- Ajoute un /d manuellement ^^
	-- Pour debug, uniquement sur user=kikiz !!
	if args ~= nil and #args > 0 and gPlayerName=="Kikiz" then
		local n,r,m = string.match(args,"(%w+) (%d+) (%d+)");
		Kiki.Commons.Trace("n=".. (n or "nil") .." r=".. (r or "nil") .. " m=".. (m or "nil") );
		wRolls:AddRoll(n,tonumber(r),tonumber(m));
	else
		wRolls:Show();
	end
end




-- Retrouve la version du plugin
Kiki.Commons.Trace("loaded (version ".. Plugins[gPluginName]:GetVersion() .. " by Kikiadoc@Sirannon)");
Kiki.Commons.Trace(gLang.USAGE);












