-- KikiRools Panel


WinRolls = class(Turbine.UI.Lotro.Window);


function WinRolls:Label(lbl,x,y,sz,tooltipText,alig)
	local wL;
	wL = Turbine.UI.Label();
	wL:SetParent(self);
	wL:SetSize(sz,20);
	wL:SetPosition(x,y);
	if alig ~= nil then
		wL:SetTextAlignment(alig);
	else
		wL:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	end
	wL:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	wL:SetText(lbl);
	Kiki.Commons.TooltipAttach(wL,tooltipText);
	return wL;
end

function WinRolls:CheckBox(lbl,x,y,sz,tooltipText)
	local ckb = Turbine.UI.Lotro.CheckBox();
	ckb:SetParent(self);
	ckb:SetSize(sz,20);
	ckb:SetMultiline(false);
	ckb:SetPosition(x,y);
	ckb:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	ckb:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	ckb:SetText(lbl);
	Kiki.Commons.TooltipAttach(ckb,tooltipText);
	return ckb;
end


-- Layout : Zone des elements  afficher
function WinRolls:AddItemList()
	self.ItemBg =Turbine.UI.Control();
	self.ItemBg:SetParent(self);
	self.ItemBg:SetPosition(10,60);
	self.ItemBg:SetSize(self:GetWidth()-20,self:GetHeight()-120);
	self.ItemBg:SetBackColor(Turbine.UI.Color(0,0,0)); 
	self.ItemBg.List=Turbine.UI.ListBox();
	self.ItemBg.List:SetParent(self.ItemBg);
	self.ItemBg.List:SetPosition(2,1);
	self.ItemBg.List:SetSize(self.ItemBg:GetWidth()-4,self.ItemBg:GetHeight()-2);
	self.ItemBg.List:SetBackColor(Turbine.UI.Color(0,0,0));
	self.ItemBg.List.VScrollBar=Turbine.UI.Lotro.ScrollBar();
	self.ItemBg.List.VScrollBar:SetOrientation(Turbine.UI.Orientation.Vertical);
	self.ItemBg.List.VScrollBar:SetParent(self.ItemBg.List);
	self.ItemBg.List.VScrollBar:SetBackColor(backColor);
	self.ItemBg.List.VScrollBar:SetPosition(self.ItemBg:GetWidth()-16,0)
	self.ItemBg.List.VScrollBar:SetWidth(12);
	self.ItemBg.List.VScrollBar:SetHeight(self.ItemBg:GetHeight()-2);
	self.ItemBg.List:SetAllowDrop( false );
	self.ItemBg.List:SetVerticalScrollBar(self.ItemBg.List.VScrollBar);
	-- Bouton de switch auto sur combat off
end
-- Layout : zone du haut
function WinRolls:AddRoundInfo()
	-- Label indiquant le dbut/fin des /ds
	self.lblStartEnd = self:Label("tbd !",10, 40, self:GetWidth()-20, gLang.TTDTH, Turbine.UI.ContentAlignment.MiddleCenter)
	-- Option indiquant le commit automatique en sortie de combat
	self.chkCombat = self:CheckBox(gLang.AUTOCOMBAT,10,self:GetHeight()-50, 100, gLang.TTAUTOCOMBAT);
	self.chkCombat:SetChecked(self.settings.AutoCombat);
	self.chkCombat.CheckedChanged = function (sender, args)
		self.settings.AutoCombat = self.chkCombat:IsChecked();
	end
	-- Option pour conserver le premier pour les tris
	self.chkFirst = self:CheckBox(gLang.FIRST,110,self:GetHeight()-50, 100, gLang.TTFIRST);
	self.chkFirst:SetChecked(self.settings.KeepFirst);
	self.chkFirst.CheckedChanged = function (sender, args)
		self.settings.KeepFirst = self.chkFirst:IsChecked();
	end
	-- Bouton de navigation dans l'historique
  	self.prevBtn = Turbine.UI.Lotro.Button();
  	self.prevBtn:SetPosition( 210 , self:GetHeight()-50);
  	self.prevBtn:SetSize( 25, 20);
  	self.prevBtn:SetParent( self );
	self.prevBtn:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.prevBtn:SetText("<");
	self.prevBtn:SetVisible(false);
	Kiki.Commons.TooltipAttach(self.prevBtn,gLang.TTPREV);
	self.prevBtn.Click = function( sender, args)
		-- On recherche l'element precedent l'historique actuel !
		if self.displayedTurn ~= nil and self.displayedTurn.prev~= nil then
			self:Reload(self.displayedTurn.prev);
		else
			Kiki.Commons.Trace("pas d'historique.... prevBtn.Click ne devrait pas tre appele");
		end;
	end
	-- Bouton de navigation dans l'historique
  	self.nextBtn = Turbine.UI.Lotro.Button();
  	self.nextBtn:SetPosition( 250, self:GetHeight()-50 );
  	self.nextBtn:SetSize( 25, 20);
  	self.nextBtn:SetParent( self );
	self.nextBtn:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.nextBtn:SetText(">");
	self.nextBtn:SetVisible(false);
	Kiki.Commons.TooltipAttach(self.nextBtn,gLang.TTNEXT);
	self.nextBtn.Click = function( sender, args)
		-- Passe  l'historique suivant
		-- On recherche l'element suivant l'historique actuel !
		local scan = self.turn;
		while scan ~= nil and scan.prev ~= self.displayedTurn do
			scan = scan.prev;
		end
		-- On a nil ou le tour suivant de celui affich !
		if scan ~= nil then
			self:Reload(scan);
		else
			Kiki.Commons.Trace("scan is nil... bug! ");
		end
	end
	-- Bouton de reinit des /d
  	self.initBtn = Turbine.UI.Lotro.Button();
  	self.initBtn:SetPosition( 295, self:GetHeight()-50);
  	self.initBtn:SetSize( 50, 20);
  	self.initBtn:SetParent( self );
	self.initBtn:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.initBtn:SetText(gLang.INIT);
	self.initBtn:SetVisible(true);
	Kiki.Commons.TooltipAttach(self.initBtn,gLang.TTINIT);
	self.initBtn.Click = function( sender, args)
		self:NewTurn();
		self:Reload(self.turn);
	end
	
end

-- Ajoute un item dans la liste
function WinRolls:AddIntoRollList(roll)
	local wL;
	local ctl;
	-- Controle principal
	ctl =Turbine.UI.Control();
	ctl:SetParent(self.ItemBg.List);
	ctl:SetSize(self.ItemBg.List:GetWidth()-20,20);
	-- ctl:SetBackColor(Turbine.UI.Color(1,1,1)); 
	-- Nom du personnage
	wL = Turbine.UI.Label();
	wL:SetParent(ctl);
	wL:SetSize(98,18);
	wL:SetPosition(1,1);
	wL:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	wL:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	wL:SetText(roll.name);
	wL:SetOutlineColor(Turbine.UI.Color(0.5,0,0));
	wL:SetFontStyle(Turbine.UI.FontStyle.Outline);
	-- Valeur du /d actif
	wL = Turbine.UI.Label();
	wL:SetParent(ctl);
	wL:SetSize(38,18);
	wL:SetPosition(101,1);
	wL:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	wL:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	if roll.rollmax ~= nil then
		if roll.rollmax ~= 100 then
			-- Alerte sur le fait que ce n'est pas un /d sur 100 !!
			wL:SetForeColor(Turbine.UI.Color( 1, 0, 0 ));
			wL:SetText(roll.roll.."*");
		else
			wL:SetText(roll.roll);
		end
		Kiki.Commons.TooltipAttach(wL,roll.name .. gLang.TTROLLMSG .. roll.rollmax.." (".. math.floor(0.5+100*roll.ratio).."%)");
	else
		-- Le roll est vide (c'est un placeholder pour un perso du raid...)
		wL:SetText("...");
	end
	-- Ajoute des lments d'historique....
	local hist = "";
	local scan = roll.prev;
	while scan ~= nil do
		if #hist > 0 then
			hist = hist ..", ";
		end
		-- Ajoute le ratio du /d
		hist = hist .. scan.roll .. "(" .. scan.rollmax ..")";
		scan = scan.prev;
	end
	-- Si historique; ajoute le controle
	if #hist > 0 then
		wL = Turbine.UI.Label();
		wL:SetParent(ctl);
		wL:SetSize(ctl:GetWidth()-142,20);
		wL:SetPosition(141,0);
		wL:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
		wL:SetFont(Turbine.UI.Lotro.Font.Verdana12);
		wL:SetText(hist);
	end	
	-- Ajoute le control dans la liste des controls
	self.ItemBg.List:AddItem(ctl);
end

function WinRolls:Constructor(profile)
	Turbine.UI.Lotro.Window.Constructor(self)
	self:SetText(gLang.WINTITLE);
	self:SetMouseVisible(false);
	self:SetSize(350,400);
	self:SetVisible(false);

	-- constantes diverses
	self.font = Turbine.UI.Lotro.Font.Verdana12;
	self.fontColor = Turbine.UI.Color(1,1,1)
	
	-- Recupere les donnes associes
	self.settingsName = profile;
	self.settings = Kiki.Commons.Settings(profile, { top=0; left=0; KeepFirst=true; AutoCombat=true } );

	-- layout
	self:AddRoundInfo();
	self:AddItemList();
		
	-- tracking de la position
	self.PositionChanged = function (sender,args)
		self.settings.top = self:GetTop();
		self.settings.left = self:GetLeft();
	end
	

	-- Positionne sur l'ecran
	self:SetPosition(self.settings.left,self.settings.top);
	-- Force le positionne sur l'ecran
	Kiki.Commons.Onscreen(self);

	-- mode combat
	self:CombatMode(gPlayer:IsInCombat());
	
	-- Commence un nouveau tour de ds
	self:NewTurn(false);
end

function WinRolls:Show()
	Kiki.Commons.Onscreen(self);
	self:SetVisible(true);
	self:Activate();
	self.turnDisplayed=nil;
	self:Reload(self.turn);
end

-- Passe le plugin en mode combat on/off
function WinRolls:CombatMode(mode)
	self.combat = mode;
	if mode==false then
		-- Sortie du mode combat.....
		if self.settings.AutoCombat==true then
			self:NewTurn();
		end
	end
end

-- Function de comparaison de rolls
function WinRolls_SortRoll(i,j)
	if i.ratio==nil and j.ratio==nil then 
		return i.name > j.name;
	end
	if i.ratio==nil then 
		return false;
	end
	if j.ratio==nil then 
		return true;
	end
	if i.ratio == j.ratio then
		-- Comparaison avec l'historique.....
		if i.prev == nil and j.prev==nil then
			-- aucun historique... compare les noms
			return i.name > j.name;
		end
		if i.prev == nil then
			return false;
		end
		if j.prev == nil then
			return true;
		end
		return WinRolls_SortRoll(i.prev,j.prev);
	end
	return i.ratio > j.ratio;
end

-- Recharge le contenu de la fenetre
function WinRolls:Reload(turn)

	-- sauve le turn courant !
	self.displayedTurn = turn;
	
	-- On efface la liste des /ds
	self.ItemBg.List:ClearItems();
	-- On balaye la liste des rolls actuels, et on labore la liste  afficher
	-- Affiche l'heure de dbut du round
	local lbl 
	if turn.endDth ~= nil then
		lbl = gLang.STARTDTH .. turn.startDth.Hour..":"..turn.startDth.Minute..":"..turn.startDth.Second .. gLang.ENDDTH .. turn.endDth.Hour..":"..turn.endDth.Minute..":"..turn.endDth.Second
	else
		lbl = gLang.ACTIVE;
	end
	self.lblStartEnd:SetText(lbl);
	
	-- On vrifie que tous les membres de la Party sont prsent dans la table de roll.... 
	local party = gPlayer:GetParty();
	if party~=nil then
		local nb = party:GetMemberCount();
		for i = 1,nb do
			local n = party:GetMember(i):GetName();
			if turn.rolls[n] == nil then
				turn.rolls[n] = {name=n; prev= nil};
			end
		end
	end
	
	-- Construit une table de tri
	local tblSort = {};
	for k,v in pairs(turn.rolls) do
		table.insert(tblSort,v);
	end
	
	-- On trie la table des rolls
	Kiki.Commons.Trace(dump(tblSort));
	table.sort(tblSort,WinRolls_SortRoll);
	
	-- On balaye la table pour afficher les elements dans la liste
	for k,v in pairs(tblSort) do
		-- Ajoute le label avec le n
		self:AddIntoRollList(v);
	end
	
	-- Modifie les boutons prev/next si besoin....
	self.prevBtn:SetVisible(turn.prev ~= nil );
	self.nextBtn:SetVisible(turn ~= self.turn);

	-- Et le bouton d'init....
	self.initBtn:SetVisible(self.turn.open==true);
		
end

function WinRolls:Unload()
	self.settings:Save(self.settingsName);
end

-- joute un roll pour le joueur n, roll=r, maxroll=m
function WinRolls:AddRoll(n,r,m)
	-- On stacke pour l'instant dans l'ordre des rolls, en gardant le premier roll ^^
	local newRoll = { name=n; roll=r; rollmax=m; ratio= r/m;  time= Turbine.Engine.GetDate(); prev= nil }; 
	if self.turn.rolls[n] ~= nil then
		if self.turn.rolls[n].ratio ~= nil then
			-- Il y a des rolls existant.... 
			-- selon les options..... 
			if self.settings.KeepFirst == true then
				-- on conserve l'actuel en "top" et on historise a la fin
				-- recherche le dernier de la liste actuelle
				local last = self.turn.rolls[n];
				while last.prev ~= nil do
					last = last.prev;
				end 
				last.prev = newRoll;
			else
				-- insere en top de liste
				newRoll.prev = self.turn.rolls[n];
				self.turn.rolls[n] = newRoll;
			end
		else
			-- le truc est un truc bidon... donc on ignore !
			self.turn.rolls[n] = newRoll;
		end
	else
		-- Un nouveau roll
		self.turn.rolls[n] = newRoll;
	end
	-- Indique qu'un roll a t ajout dans la liste
	if self.turn.open ~= true then
		self.turn.startDth = Turbine.Engine.GetDate();
		self.turn.open = true;
	end
	-- Kiki.Commons.Trace("Roll="..dump(self.rolls[n]));
	-- Si les rolls affichs sont les actuels, on reinit la fenetre !
	if self.turnDisplayed == nil and self:IsDisplayed() then
		self:Reload(self.turn);
	end
end

-- initialise un nouveau tour de ds
function WinRolls:NewTurn()
	if self.turn ~= nil then
		if self.turn.open == false then
			-- Si il y a un turn et qu'il n'est pas open, on ne fait rien !!
			-- On peut continuer  l'utiliser !!
			self.turn.startDth=Turbine.Engine.GetDate(); 
			return;
		end
		self.turn.endDth=Turbine.Engine.GetDate();
	end
	Kiki.Commons.Trace(gLang.NEWROUND);
	self.turn = {rolls={}; startDth=Turbine.Engine.GetDate(); endDth=nil; open=false; prev = self.turn  };
end


-- Filtre les messages de chats
-- Utilisation de find et pas de pattern complexe pour aller vite, meme si c'est moins elegant !
function WinRolls:FilterMessage(sender,args)
	-- Les /d sont dans le chat standard, que l'on examine que si le mode combat est off ....
	if self.combat ~= false then return end
	-- On n'analyse que le chat standard pour les /d
	-- if args.ChatType ~= Turbine.ChatType.Standard then return end

	local msg = args.Message;
	local deb,paro = string.find(msg,gLang.ROLLMSG,1,true);
	if deb == nil then return end
	
	-- contient sequence, on recherche le ')' apres le '('
	local parf = string.find(msg,")",paro+1,true);
	if parf == nil then return end
	
	-- contient sequence, '(', et ')', on vrifie qu'il y a un ":" juste apres
	local pt = string.find(msg,":",parf+1,true);
	if pt == nil or pt>(parf+3) then return end
	
	-- contient sequence, '(', et ')', un ":" juste apres, on vrifie qu'entre () c'est bien numrique
	local m = tonumber(string.sub(msg,paro+1,parf-1));
	if m == nil then return end
	
	-- Message contient la sequence magique Nom blablabla nnn(mmm)
	local name = string.sub(msg,1,deb-1);
	local roll = tonumber(string.sub(msg,pt+1));

	self:AddRoll(name,roll,m);
end

wRolls = WinRolls(gPluginName.."_panel"); 


